// Copyright 2016 Orus.io. All rights reserved.

package cmd

import (
	"github.com/spf13/cobra"
)

var envelopeCmd = &cobra.Command{
	Use:   "envelope",
	Short: "Envelope management",
}

var envelopePurgeCmd = &cobra.Command{
	Use:   "purge",
	Short: "Remove envelopes that are not in an existing process",
	Run: func(cmd *cobra.Command, args []string) {
		c, err := GetClient()
		if err != nil {
			return
		}
		count, err := c.EnvelopePurge()
		if err != nil {
			Logger.Errorf("%s", err)
			return
		}
		Logger.Noticef("Purged %d envelope(s)", count)
	},
}

func init() {
	RootCmd.AddCommand(envelopeCmd)
	envelopeCmd.AddCommand(envelopePurgeCmd)
}
