package fullenv

import (
	"testing"
	"time"
)

// TestFlood sends a lot of small messages in a minimum of time, and see if
// nothing fails
func TestFlood(t *testing.T) {
	env, _ := NewFullEnvForTest(t, "flood", "flood.yaml")

	if err := env.Init(); err != nil {
		t.Fatal(err)
	}

	defer env.Close()
	cr := NewCounterReceiver(t, 2000)
	env.RegisterActorService("test.receivecounter", cr.Service)

	if err := env.Startup(); err != nil {
		t.Fatal(err)
	}

	t.Log("Waiting for completion")
	select {
	case <-cr.receivedAll:
		t.Log("Everything's alright")
	case <-time.After(180 * time.Second):
		t.Errorf("Reception timeout")
		t.Errorf("Next number expected: %d", cr.nextExpected)
		t.Errorf("Missing numbers: %v", cr.missingnumbers)
	}
}
