ALTER TABLE route
    DROP CONSTRAINT route_process_id_fkey,
    ADD CONSTRAINT route_process_id_fkey
        FOREIGN KEY (process_id) REFERENCES process(id) ON DELETE CASCADE;

ALTER TABLE route_target
    DROP CONSTRAINT route_target_route_id_fkey,
    ADD CONSTRAINT route_target_route_id_fkey
        FOREIGN KEY (route_id) REFERENCES route(id) ON DELETE CASCADE;

ALTER TABLE emission
    DROP CONSTRAINT emission_process_id_fkey,
    ADD CONSTRAINT emission_process_id_fkey
        FOREIGN KEY (process_id) REFERENCES process(id) ON DELETE CASCADE;

ALTER TABLE process_log_entry
    DROP CONSTRAINT process_log_entry_process_id_fkey,
    ADD CONSTRAINT process_log_entry_process_id_fkey
        FOREIGN KEY (process_id) REFERENCES process(id) ON DELETE CASCADE;

ALTER TABLE process_state
    DROP CONSTRAINT process_state_process_id_fkey,
    ADD CONSTRAINT process_state_process_id_fkey
        FOREIGN KEY (process_id) REFERENCES process(id) ON DELETE CASCADE;

ALTER TABLE process_state
    ADD COLUMN status_changed timestamp without time zone,
    ADD COLUMN node_states_changed timestamp without time zone,
    ADD COLUMN pm_changed timestamp without time zone;

UPDATE process_state SET
    status_changed = (
        SELECT MAX(timestamp) FROM process_log_entry
        WHERE process_log_entry.process_id = process_state.process_id),

    node_states_changed = (
        SELECT MAX(timestamp) FROM process_log_entry
        WHERE process_log_entry.process_id = process_state.process_id);

UPDATE process_state SET
    pm_changed = (
        SELECT MAX(timestamp) FROM process_log_entry
        WHERE process_log_entry.process_id = process_state.process_id)

    WHERE process_state.status IN ('done', 'error');

UPDATE process_state SET
    pm_changed = '0001-01-01' WHERE pm_changed IS NULL;

ALTER TABLE process_state
    ALTER COLUMN status_changed SET NOT NULL,
    ALTER COLUMN node_states_changed SET NOT NULL,
    ALTER COLUMN pm_changed SET NOT NULL;
