// Copyright 2017 Orus.io. All rights reserved.

package sql

import (
	"testing"

	"github.com/slicebit/qb"

	"bitbucket.org/orus-io/go-xbus/api"
	"bitbucket.org/orus-io/xbus/testutils"
	"bitbucket.org/orus-io/xbus/testutils/sqldb"
)

func TestLog(t *testing.T) {
	logger := testutils.GetTestLogger(t)
	defer logger.VerifyExpectations()

	testDB := sqldb.GetTestDB(t)
	if testDB == nil {
		return
	}
	defer testDB.Close()

	m, db := testDB.GetModelDB(1)
	defer db.Close()

	logStorage := NewLogStorage(m, db, logger)
	db.Engine.SetLogFlags(qb.LQuery | qb.LBindings)

	logentry := api.LogEntry{
		Message: api.LogMessage{Text: "test"},
	}

	logStorage.Log(logentry)
}
