// Copyright 2016 Orus.io. All rights reserved.

package model

import (
	"bitbucket.org/orus-io/go-xbus/api"

	"github.com/m4rw3r/uuid"
)

//go:generate yago --fmt

// Graph stores graph data
//yago:autoattrs
type Graph struct {
	Base
	Name    string          `yago:"unique_index=name_version"`
	Version string          `yago:"unique_index=name_version"`
	Status  api.GraphStatus `yago:"textmarshaled"`
	Edges   string          `yago:"type=qb.Text()"`
}

// GraphNode is a graph vertex
//yago:autoattrs
type GraphNode struct {
	ID                    int64     `yago:"auto_increment,primary_key"`
	GraphID               uuid.UUID `yago:"fk=Graph,unique_index=graph_node"`
	NodeID                string    `yago:"unique_index=graph_node"`
	Type                  string
	ActorIDs              string
	Actors                string
	Roles                 string
	RoleBroadcast         bool
	SourceMatchEventTypes string
	Inputs                string
	Outputs               string
}
