package api

import (
	"github.com/m4rw3r/uuid"
)

const (
	// ProcessStatePrefix is the prefix for process state apis
	ProcessStatePrefix = XbusAPIPrefix + "processstate."
)

// EmitterEnvelopeStateSubject returns the subject on which process events are sent
func EmitterEnvelopeStateSubject(emitter uuid.UUID, envelopeID uuid.UUID) string {
	subject := ProcessStatePrefix
	if emitter.IsZero() {
		subject += "*"
	} else {
		subject += emitter.String()
	}
	subject += "."
	if envelopeID.IsZero() {
		subject += "*"
	} else {
		subject += envelopeID.String()
	}
	return subject
}

// EmitterEnvelopeState combines statuses of the processed triggered by an envelope
type EmitterEnvelopeState struct {
	ProcessStatusList map[uuid.UUID]ProcessStatus
	Status            ProcessStatus
	Errors            map[uuid.UUID][]LogMessage
}
